//计算等待的价格
function  waitingFee(wt,up,ut){//wt:等待的时间（分）;ut:单位等待时间（分）;up:单位等待价格（元）;
	var totalfee = Math.floor(wt/ut)*up;
	return totalfee;
}
//计算起步的价格
function  startFee(){
	var sp1 = 29;
	var sp2 = 39;
	var now = new Date().getHours();
	if(now>=7&&now<22){
		return sp1;
	}else{
		return sp2;
	}
}
//计算超出的价格
function  overFee(ts,ss,us,up){//ts:总路程（km）;ss:起步路程（km）;;us:超出的单位公里数（km）;up:单位公里价格（元）;
	var overfee = (Math.ceil((ts-ss)/us))*up;
	return overfee;
}

//当前时间，年月日，星期
var date_time = function(){
	var time = new Date();
	var date_t = time.getFullYear()+"年"+(time.getMonth()+1)+"月"+time.getDate()+"日"+" "+"星期"+'日一二三四五六'.charAt(time.getDay());
	return date_t
}
//日期格式
var date_format = function(date){
	var path = new RegExp(/^\d{4}-\d{1,2}-\d{1,2}/);
	return path.test(date)
}
//身份证
var id_format = function(id){
	var path = new RegExp(/^[1-9]\d{5}[1-9]\d{3}((0\d)|(1[0-2]))(([0|1|2]\d)|3[0-1])\d{4}$/);
	return path.test(id)
}
//密码
var pass_format = function(pass){
	var path = new RegExp(/^[A-Za-z0-9]{6,20}$/);
	return path.test(pass)
}


//只能输入数字
var sole_number = function(str){
	var path = new RegExp(/^\d{4}-\d{1,2}-\d{1,2}/);
	return path.test(str)
}
//关闭某个页面
var close_other = function(url){
	var str = url.substr()
	var person = plus.webview.getWebviewById(url);
	person.close('none');
}
//调用某个页面的方法
var other_method = function(url,method){
	var page = plus.webview.getWebviewById(url);
	page.evalJS(method);
}
//判断只能输入数字
var check_bank = function(str){
	var pat = new RegExp(/^[0-9]{16,19}$/);
	return pat.test(str)
}

//比较时间大小,//第一个时间大于第二个时间为true，否则为false
var compare_time = function(time_one,time_two){
	var time_o = new Date(time_one.replace(/-/g,"/"));
	var time_t = new Date(time_two.replace(/-/g,"/"));
	var flag;
	if (time_one > time_two) {
		flag = true;
	} else {
		flag = false;
	}
	return flag
}


//打开新页面
var OpenView = function(url){
	var id = getViewIdStr(url);
	mui.openWindow({
		url:url,
		id:id
	});
}
//获取http 地址
var getHttpAddress = function(){
	var httpAddress = "121.43.104.55/partycar";
	//var httpAddress = "192.168.2.130:8099/partycar";
	//var httpAddress = "192.168.1.103:8099/partycar";
	return httpAddress;
}

//获取http图片地址
var getHttpAddress_image = function(){
	//var httpAddress_image = '192.168.2.130:8099/partycar/index.php/Public/Uploads/s_';
	//var httpAddress_image = 'http://192.168.2.102:8099/partycar/Public/Uploads/s_';
	var httpAddress_image = 'http://121.43.104.55/partycar/Public/Uploads/s_';
	return httpAddress_image;
}

//获取页面的id
var getViewIdStr = function(href) {
	var idstr;
	if (href.lastIndexOf('/') == -1) {
		idstr = href.substring(0, href.lastIndexOf('.'));
	} else {
		idstr = href.substring(href.lastIndexOf('/') + 1, href.lastIndexOf('.'));
	}

	return idstr;
}
//获取图片的名称
var ycGetPicName = function(imgPath){
	picName = imgPath.substring(imgPath.lastIndexOf('/')+1);
	return picName;
	
}
//获取图片的类型
var ycGetPicType = function(imgPath){
	picType = imgPath.substring(imgPath.lastIndexOf('.'));
	return picType;
	
}


//获取图片的路径
var ycGetPicPath = function(imgPath){
	
	picPath = imgPath.substring(0,imgPath.lastIndexOf('/')+1);
	return picPath;
	
}

//取字符串的空白
var ycStrTrim = function(str) {
	strObj = str+""
	return strObj.replace(/(^\s*)|(\s*$)/g, "");
}

//判断是否为手机号
var ycIsTelCode = function(str) {
	var pat = new RegExp(/^(0|86|17951)?(13[0-9]|15[012356789]|17[678]|18[0-9]|14[57])[0-9]{8}$/);
	return pat.test(str);
}

//判断是否为空
var ycIsNullUndeEmpty = function(str) {
	if (str == null || str == undefined || ycStrTrim(str).length == 0){
		return true;//表示为空
	}else{
		return false;//表示不为空
	}
		
}

//判断对象是否为空
var ycObjIsNullUndefined = function(str) {
	if (str == null || str == undefined || ycStrTrim(str).length == 0)
		return true;//表示为空
}

//验证登陆密码
var ycVeriPwd = function(str) {
	var regex = new RegExp(/^[a-zA-Z0-9]{6,15}$/);
	return regex.test(str);
}

//验证价格
var ycVeriPrice = function(str){
	var regex = new RegExp(/^(d*.d{0,2}|d+).*$/);
	return regex.test(str);
}

//打开新页面
var ycOpenView = function(url, iscreateNew, stylesArr, extrasArr, animationType, animationTime, iswaiting) {
	var id = getViewIdStr(url);
	mui.openWindow({
		url: url,
		id: id,
		styles: stylesArr,
		extras: extrasArr,
		createNew: iscreateNew, //是否重复创建同样id的webview，默认为false:不重复创建，直接显示
		show: {
			autoShow: true, //页面loaded事件发生后自动显示，默认为true
			aniShow: animationType, //页面显示动画，默认为”slide-in-right“；
			duration: animationTime //页面动画持续时间，Android平台默认100毫秒，iOS平台默认200毫秒；
		},
		waiting: {
			autoShow: iswaiting, //自动显示等待框，默认为true
		}
	})
}

var ycOpenViewSimpple = function(url,extrasArr) {
	var id = getViewIdStr(url);
	mui.openWindow({
		url: url,
		id: id,
		extras: extrasArr,
		show: {
			autoShow: true, //页面loaded事件发生后自动显示，默认为true
			aniShow: 'pop-in', //页面显示动画，默认为”slide-in-right“；
			duration: '300' //页面动画持续时间，Android平台默认100毫秒，iOS平台默认200毫秒；
		},
		waiting: {
			autoShow: false, //自动显示等待框，默认为true
		}
	})
}

var ycOpenViewSimppleMini = function(url) {
	var id = getViewIdStr(url);
	mui.openWindow({
		url: url,
		id: id,
		createNew: true,
		show: {
			autoShow: true, //页面loaded事件发生后自动显示，默认为true
			aniShow: 'pop-in', //页面显示动画，默认为”slide-in-right“；
			duration: '300', //页面动画持续时间，Android平台默认100毫秒，iOS平台默认200毫秒；
		},
		waiting: {
			autoShow: false, //自动显示等待框，默认为true
		}
	})
}

//格式化日期格式
Date.prototype.format = function(format){ 
var o = { 
"M+" : this.getMonth()+1, //month 
"d+" : this.getDate(), //day 
"h+" : this.getHours(), //hour 
"m+" : this.getMinutes(), //minute 
"s+" : this.getSeconds(), //second 
"q+" : Math.floor((this.getMonth()+3)/3), //quarter 
"S" : this.getMilliseconds() //millisecond 
} 

if(/(y+)/.test(format)) { 
format = format.replace(RegExp.$1, (this.getFullYear()+"").substr(4 - RegExp.$1.length)); 
} 

for(var k in o) { 
if(new RegExp("("+ k +")").test(format)) { 
format = format.replace(RegExp.$1, RegExp.$1.length==1 ? o[k] : ("00"+ o[k]).substr((""+ o[k]).length)); 
} 
} 
return format; 
} 


//将图片生成base64
var base64;
var ycImgToBase64 = function(path) {
	var img = new Image();
	img.src = path; // 传过来的图片路径在这里用。
	img.onload = function() {
		var that = this;
		var w = that.width;
		var h = that.height;
		//生成canvas
		var canvas = document.createElement('canvas');
		var ctx = canvas.getContext('2d');
		$(canvas).attr({
			width: w,
			height: h
		});
		ctx.drawImage(that, 0, 0, w, h);
		base64 = canvas.toDataURL('image/jpeg', 1 || 0.8); //1最清晰，越低越模糊。有一点不清楚这里明明设置的是jpeg。弹出 base64 开头的一段 data：image/png;却是png。哎开心就好，开心就好
		return base64;

	}
		console.log('base64:' + base64);
}



/**
 * md5加密
 */

var hexcase = 0;
var b64pad = "";
var chrsz = 8;

function hex_md5(s) {
	return binl2hex(core_md5(str2binl(s), s.length * chrsz));
}

function b64_md5(s) {
	return binl2b64(core_md5(str2binl(s), s.length * chrsz));
}

function hex_hmac_md5(key, data) {
	return binl2hex(core_hmac_md5(key, data));
}

function b64_hmac_md5(key, data) {
	return binl2b64(core_hmac_md5(key, data));
}

function calcMD5(s) {
	return binl2hex(core_md5(str2binl(s), s.length * chrsz));
}

function md5_vm_test() {
	return hex_md5("abc") == "900150983cd24fb0d6963f7d28e17f72";
}

function core_md5(x, len) {

	x[len >> 5] |= 0x80 << ((len) % 32);
	x[(((len + 64) >>> 9) << 4) + 14] = len;
	var a = 1732584193;
	var b = -271733879;
	var c = -1732584194;
	var d = 271733878;
	for (var i = 0; i < x.length; i += 16) {
		var olda = a;
		var oldb = b;
		var oldc = c;
		var oldd = d;

		a = md5_ff(a, b, c, d, x[i + 0], 7, -680876936);
		d = md5_ff(d, a, b, c, x[i + 1], 12, -389564586);
		c = md5_ff(c, d, a, b, x[i + 2], 17, 606105819);
		b = md5_ff(b, c, d, a, x[i + 3], 22, -1044525330);
		a = md5_ff(a, b, c, d, x[i + 4], 7, -176418897);
		d = md5_ff(d, a, b, c, x[i + 5], 12, 1200080426);
		c = md5_ff(c, d, a, b, x[i + 6], 17, -1473231341);
		b = md5_ff(b, c, d, a, x[i + 7], 22, -45705983);
		a = md5_ff(a, b, c, d, x[i + 8], 7, 1770035416);
		d = md5_ff(d, a, b, c, x[i + 9], 12, -1958414417);
		c = md5_ff(c, d, a, b, x[i + 10], 17, -42063);
		b = md5_ff(b, c, d, a, x[i + 11], 22, -1990404162);
		a = md5_ff(a, b, c, d, x[i + 12], 7, 1804603682);
		d = md5_ff(d, a, b, c, x[i + 13], 12, -40341101);
		c = md5_ff(c, d, a, b, x[i + 14], 17, -1502002290);
		b = md5_ff(b, c, d, a, x[i + 15], 22, 1236535329);
		a = md5_gg(a, b, c, d, x[i + 1], 5, -165796510);
		d = md5_gg(d, a, b, c, x[i + 6], 9, -1069501632);
		c = md5_gg(c, d, a, b, x[i + 11], 14, 643717713);
		b = md5_gg(b, c, d, a, x[i + 0], 20, -373897302);
		a = md5_gg(a, b, c, d, x[i + 5], 5, -701558691);
		d = md5_gg(d, a, b, c, x[i + 10], 9, 38016083);
		c = md5_gg(c, d, a, b, x[i + 15], 14, -660478335);
		b = md5_gg(b, c, d, a, x[i + 4], 20, -405537848);
		a = md5_gg(a, b, c, d, x[i + 9], 5, 568446438);
		d = md5_gg(d, a, b, c, x[i + 14], 9, -1019803690);
		c = md5_gg(c, d, a, b, x[i + 3], 14, -187363961);
		b = md5_gg(b, c, d, a, x[i + 8], 20, 1163531501);
		a = md5_gg(a, b, c, d, x[i + 13], 5, -1444681467);
		d = md5_gg(d, a, b, c, x[i + 2], 9, -51403784);
		c = md5_gg(c, d, a, b, x[i + 7], 14, 1735328473);
		b = md5_gg(b, c, d, a, x[i + 12], 20, -1926607734);
		a = md5_hh(a, b, c, d, x[i + 5], 4, -378558);
		d = md5_hh(d, a, b, c, x[i + 8], 11, -2022574463);
		c = md5_hh(c, d, a, b, x[i + 11], 16, 1839030562);
		b = md5_hh(b, c, d, a, x[i + 14], 23, -35309556);
		a = md5_hh(a, b, c, d, x[i + 1], 4, -1530992060);
		d = md5_hh(d, a, b, c, x[i + 4], 11, 1272893353);
		c = md5_hh(c, d, a, b, x[i + 7], 16, -155497632);
		b = md5_hh(b, c, d, a, x[i + 10], 23, -1094730640);
		a = md5_hh(a, b, c, d, x[i + 13], 4, 681279174);
		d = md5_hh(d, a, b, c, x[i + 0], 11, -358537222);
		c = md5_hh(c, d, a, b, x[i + 3], 16, -722521979);
		b = md5_hh(b, c, d, a, x[i + 6], 23, 76029189);
		a = md5_hh(a, b, c, d, x[i + 9], 4, -640364487);
		d = md5_hh(d, a, b, c, x[i + 12], 11, -421815835);
		c = md5_hh(c, d, a, b, x[i + 15], 16, 530742520);
		b = md5_hh(b, c, d, a, x[i + 2], 23, -995338651);
		a = md5_ii(a, b, c, d, x[i + 0], 6, -198630844);
		d = md5_ii(d, a, b, c, x[i + 7], 10, 1126891415);
		c = md5_ii(c, d, a, b, x[i + 14], 15, -1416354905);
		b = md5_ii(b, c, d, a, x[i + 5], 21, -57434055);
		a = md5_ii(a, b, c, d, x[i + 12], 6, 1700485571);
		d = md5_ii(d, a, b, c, x[i + 3], 10, -1894986606);
		c = md5_ii(c, d, a, b, x[i + 10], 15, -1051523);
		b = md5_ii(b, c, d, a, x[i + 1], 21, -2054922799);
		a = md5_ii(a, b, c, d, x[i + 8], 6, 1873313359);
		d = md5_ii(d, a, b, c, x[i + 15], 10, -30611744);
		c = md5_ii(c, d, a, b, x[i + 6], 15, -1560198380);
		b = md5_ii(b, c, d, a, x[i + 13], 21, 1309151649);
		a = md5_ii(a, b, c, d, x[i + 4], 6, -145523070);
		d = md5_ii(d, a, b, c, x[i + 11], 10, -1120210379);
		c = md5_ii(c, d, a, b, x[i + 2], 15, 718787259);
		b = md5_ii(b, c, d, a, x[i + 9], 21, -343485551);

		a = safe_add(a, olda);
		b = safe_add(b, oldb);
		c = safe_add(c, oldc);
		d = safe_add(d, oldd);
	}
	return Array(a, b, c, d);

}

function md5_cmn(q, a, b, x, s, t) {
	return safe_add(bit_rol(safe_add(safe_add(a, q), safe_add(x, t)), s), b);
}

function md5_ff(a, b, c, d, x, s, t) {
	return md5_cmn((b & c) | ((~b) & d), a, b, x, s, t);
}

function md5_gg(a, b, c, d, x, s, t) {
	return md5_cmn((b & d) | (c & (~d)), a, b, x, s, t);
}

function md5_hh(a, b, c, d, x, s, t) {
	return md5_cmn(b ^ c ^ d, a, b, x, s, t);
}

function md5_ii(a, b, c, d, x, s, t) {
	return md5_cmn(c ^ (b | (~d)), a, b, x, s, t);
}

function core_hmac_md5(key, data) {
	var bkey = str2binl(key);
	if (bkey.length > 16) bkey = core_md5(bkey, key.length * chrsz);

	var ipad = Array(16),
		opad = Array(16);
	for (var i = 0; i < 16; i++) {
		ipad[i] = bkey[i] ^ 0x36363636;
		opad[i] = bkey[i] ^ 0x5C5C5C5C;
	}

	var hash = core_md5(ipad.concat(str2binl(data)), 512 + data.length * chrsz);
	return core_md5(opad.concat(hash), 512 + 128);
}

function safe_add(x, y) {
	var lsw = (x & 0xFFFF) + (y & 0xFFFF);
	var msw = (x >> 16) + (y >> 16) + (lsw >> 16);
	return (msw << 16) | (lsw & 0xFFFF);
}

function bit_rol(num, cnt) {
	return (num << cnt) | (num >>> (32 - cnt));
}

function str2binl(str) {
	var bin = Array();
	var mask = (1 << chrsz) - 1;
	for (var i = 0; i < str.length * chrsz; i += chrsz)
		bin[i >> 5] |= (str.charCodeAt(i / chrsz) & mask) << (i % 32);
	return bin;
}

function binl2hex(binarray) {
	var hex_tab = hexcase ? "0123456789ABCDEF" : "0123456789abcdef";
	var str = "";
	for (var i = 0; i < binarray.length * 4; i++) {
		str += hex_tab.charAt((binarray[i >> 2] >> ((i % 4) * 8 + 4)) & 0xF) +
			hex_tab.charAt((binarray[i >> 2] >> ((i % 4) * 8)) & 0xF);
	}
	return str;
}

function binl2b64(binarray) {
	var tab = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
	var str = "";
	for (var i = 0; i < binarray.length * 4; i += 3) {
		var triplet = (((binarray[i >> 2] >> 8 * (i % 4)) & 0xFF) << 16) | (((binarray[i + 1 >> 2] >> 8 * ((i + 1) % 4)) & 0xFF) << 8) | ((binarray[i + 2 >> 2] >> 8 * ((i + 2) % 4)) & 0xFF);
		for (var j = 0; j < 4; j++) {
			if (i * 8 + j * 6 > binarray.length * 32) str += b64pad;
			else str += tab.charAt((triplet >> 6 * (3 - j)) & 0x3F);
		}
	}
	return str;
}